using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Cus_Customerrecords
    /// </summary>
    public partial class T_Cus_Customerrecords
    {
        public T_Cus_Customerrecords()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_Id", "T_Cus_Customerrecords");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(string F_Cuscode, string F_Cuscodeuuid, int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Cus_Customerrecords");
            strSql.Append(" where F_Cuscode=@F_Cuscode and F_Cuscodeuuid=@F_Cuscodeuuid and F_Id=@F_Id ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Cuscode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Cuscodeuuid", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)          };
            parameters[0].Value = F_Cuscode;
            parameters[1].Value = F_Cuscodeuuid;
            parameters[2].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool ExistsCuscodeuuid( string F_Cuscodeuuid)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Cus_Customerrecords");
            strSql.Append(" where F_Cuscodeuuid=@F_Cuscodeuuid ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Cuscodeuuid", SqlDbType.NVarChar,50),
                        };
            parameters[0].Value = F_Cuscodeuuid;
            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Cus_Customerrecords model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Cus_Customerrecords(");
            strSql.Append("F_Cuscode,F_Cuscodeuuid,F_AddTime,F_Type)");
            strSql.Append(" values (");
            strSql.Append("@F_Cuscode,@F_Cuscodeuuid,@F_AddTime,@F_Type)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Cuscode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Cuscodeuuid", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AddTime", SqlDbType.DateTime),
             new SqlParameter("@F_Type", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Cuscode;
            parameters[1].Value = model.F_Cuscodeuuid;
            parameters[2].Value = model.F_AddTime;
            parameters[3].Value = model.F_Type;
            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Cus_Customerrecords model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Cus_Customerrecords set ");
            strSql.Append("F_AddTime=@F_AddTime");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_AddTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Id", SqlDbType.Int,4),
                    new SqlParameter("@F_Cuscode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Cuscodeuuid", SqlDbType.NVarChar,50)};
            parameters[0].Value = model.F_AddTime;
            parameters[1].Value = model.F_Id;
            parameters[2].Value = model.F_Cuscode;
            parameters[3].Value = model.F_Cuscodeuuid;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Cus_Customerrecords ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(string F_Cuscode, string F_Cuscodeuuid, int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Cus_Customerrecords ");
            strSql.Append(" where F_Cuscode=@F_Cuscode and F_Cuscodeuuid=@F_Cuscodeuuid and F_Id=@F_Id ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Cuscode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Cuscodeuuid", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)          };
            parameters[0].Value = F_Cuscode;
            parameters[1].Value = F_Cuscodeuuid;
            parameters[2].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Cus_Customerrecords ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Cus_Customerrecords GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_Cuscode,F_Cuscodeuuid,F_AddTime from T_Cus_Customerrecords ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

           Model.T_Cus_Customerrecords model = new Model.T_Cus_Customerrecords();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Cus_Customerrecords DataRowToModel(DataRow row)
        {
            Model.T_Cus_Customerrecords model = new Model.T_Cus_Customerrecords();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_Cuscode"] != null)
                {
                    model.F_Cuscode = row["F_Cuscode"].ToString();
                }
                if (row["F_Cuscodeuuid"] != null)
                {
                    model.F_Cuscodeuuid = row["F_Cuscodeuuid"].ToString();
                }
                if (row["F_AddTime"] != null && row["F_AddTime"].ToString() != "")
                {
                    model.F_AddTime = DateTime.Parse(row["F_AddTime"].ToString());
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int .Parse(row["F_Type"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_Cuscode,F_Cuscodeuuid,F_AddTime ");
            strSql.Append(" FROM T_Cus_Customerrecords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_Cuscode,F_Cuscodeuuid,F_AddTime ");
            strSql.Append(" FROM T_Cus_Customerrecords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Cus_Customerrecords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Cus_Customerrecords T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Cus_Customerrecords";
			parameters[1].Value = "F_Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}